# Programma dimostrativo per gli allineamenti delle word
# in memoria e nei registri.

        .data
carat:  .byte  0x21
        .byte  0x22
        .align 2         # riallineo i dati alle word
testo:  .asciiz "0123456789"
space:  .asciiz " "
        .text
        .globl main
main:
        li $v0 , 4       # seleziono con $v0 la syscall print_str (4)
        la $a0 , testo   # indico in $a0 la stringa da stampare
        syscall          # invoco la syscall

        li $v0 , 4       # stampo uno spazio
        la $a0 , space
        syscall

        la $a0 , testo   # carico i primi 4 caratteri come fossero una word
        lw $t0 , 0($a0)
        #lw $t0 , 1($a0) # questa linea genera un eccezione perch
                         # la word puntata non  allineata correttamente
        li $v0 , 1       # seleziono con $v0 la syscall print_int (1)
        move $a0 , $t0   # indico in $a0 l'intero da stampare
        syscall

        li $v0 , 4       # stampo uno spazio
        la $a0 , space
        syscall

        la $a0, carat    # carico l'indirizzo del byte puntato da carat
        lbu $t0, 0($a0)
        move $a0 , $t0
        li $v0 , 1
        syscall

        li $v0 , 4       # stampo uno spazio
        la $a0 , space
        syscall

        la $a0, carat    # carico l'indirizzo del byte puntato da carat
        lbu $t0, 1($a0)  # qui l'allineamento  irrilevante perch stiamo
        li $v0 , 1       # trasferendo un byte.
        move $a0 , $t0
        syscall

        li $v0 , 4       # stampo uno spazio
        la $a0 , space
        syscall

        la $a0, carat    # carico l'indirizzo del byte puntato da carat
        lhu $t0, 2($a0)  # qui l'allineamento  importante perch stiamo
        #lhu $t0, 1($a0)  # qui l'allineamento  importante perch stiamo
        li $v0 , 1       # trasferendo una half-word.
        move $a0 , $t0
        syscall

        li $v0 , 1       # exit
        syscall
